<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Students extends Controller_UserEnvi {

    public function action_index()
    {
        // VIEW
        $twig = Twig::factory('admin/students/index');
        $twig->Faculties = DataArray::factory('Faculties')->common()->asArray();
        $twig->Grades = DataArray::factory('Grades')->common()->asArray();
        $twig->User = $this->UserInfo;
        $this->response->body($twig);        
    }
    
    public function action_add()
    {
        $twig = Twig::factory('admin/students/add');
        $twig->Faculties = DataArray::factory('Faculties')->common()->asArray();
        $twig->Grades = $this->getGrades();
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    public function action_upload()
    {
        if(!empty($_FILES['students']) AND $this->request->method() == 'POST')
        {
            $result = $this->parseFile($_FILES["students"]["tmp_name"]);
        }
        // VIEW
        $twig = Twig::factory('admin/students/upload');
        $twig->Faculties = DataArray::factory('Faculties')->common()->asArray();
        $twig->UploadingResult = $result;
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }

    public function action_edit()
    {
        $twig = Twig::factory('admin/students/edit');    
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    protected function parseFile($filename)
    {
        return FileParser::StudentsList($filename, $_POST['facultyID']);
    }
 
    public function getGrades() {
        $model = new Model_Admin_Students();
        $grades = DataArray::factory('Grades')->common()->asArray();
        $gradesHandled = array(); $i = $j = 0; $degree = 'null';
        $degrees = array('bachelor' => 'Бакалавриат', 'specialist' => 'Специалитет', 'master' => 'Магистратура');
        foreach($grades as $row)
        {
            if($degree != $row['Degree'])
            {
                $degree = $row['Degree'] ;
                $i++; $j = 0;
            }
            $j++;
            $gradesHandled[$i]['Title'] = $degrees[$row['Degree']];
            $gradesHandled[$i]['Grades'][$j]['ID'] = $row['ID'];
            $gradesHandled[$i]['Grades'][$j]['Num'] = $row['Num'];
        }
        return $gradesHandled;
    }    
}
            